#!/usr/bin/env python

import hashlib
import sha256
from binascii import a2b_hex, b2a_hex

class Comp4P(object):
    def __init__(self, h0 = None, h1 = None, text = ""):
	if h0 is None:
            self.h0 = sha256.SHA256
        elif callable(h0):
	    self.h0 = h0
        else:
            self.h0 = lambda d='':h0.new(d)

	if h1 is None:
	    self.h1 = sha256.SHA256
        elif callable(h1):
	    self.h1 = h1
        else:
            self.h1 = lambda d='':h1.new(d)

	blen1 = len(self.h0().digest())
	blen2 = len(self.h1().digest())
	#need to preocess the different length here
	if blen1 > blen2 :
	    self.blen = blen2
	elif blen1 < blen2:
	    self.blen = blen1
	else:
	    self.blen = blen1

#        self.ltemp = text
#	self.rtemp = text

	self.hlins = self.h0()
	self.hrins = self.h1()

        if text != "" :
	    self.hlins.update(text)
	    self.hrins.update(text)
            
    def setText(self, text):
#        self.ltemp = text
#	self.rtemp = text
        self.hlins.update(text)
	self.hrins.update(text)

    def update(self, m):
        self.hlins.update(m)
	self.hrins.update(m)

    def digest(self):
	self.left = self.hlins.digest()
	self.right = self.hrins.digest()
	
	self.feistelround(self.f1)
#	print 'in comp', b2a_hex(self.left + self.right),'\n'
	self.feistelround(self.f2)
#	print 'in comp', b2a_hex(self.left + self.right),'\n'
	self.feistelround(self.f3)
#	print 'in comp', b2a_hex(self.left + self.right),'\n'

	self.result = self.right + self.left
	return self.result

    def hexdigest(self):
	return b2a_hex(self.digest())
        
    def feistelround(self, f):
	l = self.left
	self.left = self.right
	xor1 = f(self.right)
	self.right = "".join(chr(ord(xor1[i]) ^ ord(l[i])) for i in xrange(self.blen))

    def f1(self, m):
        return m

    def f2(self, m):
        msg = chr(0x02) + m
	a1 = self.hash0(msg)
	a2 = self.hash1(msg)
	return "".join(chr(ord(a1[i]) ^ ord(a2[i])) for i in xrange(self.blen))

    def f3(self, m):
        msg = chr(0x03) + m
	a1 = self.hash0(msg)
	a2 = self.hash1(msg)
	return "".join(chr(ord(a1[i]) ^ ord(a2[i])) for i in xrange(self.blen))
        
    def hash0(self, m):
#        self.h0().update(m)
#	return self.h0.digest()
        return self.h0(m).digest()
        
    def hash1(self, m):
#        self.h1().update(m)
#	return self.h1.digest()
        return self.h1(m).digest()

def new( h0 = None, h1 = None):
    return Comp4P(h0, h1)

    

        
        
